#ifndef __Gui_h__
/*--------------------------------------------------------------------------
Gui.H

Simple Gui For OLED12864
Copyleft (c) 2024~2024 NCY
All rights reversed.

--------------------------------------------------------------------------*/
#define __Gui_h__
#include "TYPE.h"
#include "_STC8X_.h"
#include "intrins.h"
#include "oled.h"
#include "Graphic_Font.h"
#include "Key.h"
#include <math.h>

#define ScreenHeight 64  //Ļ
#define ScreenWidth 128  //Ļ
#define Gui_MemPoolSize 1024+128 //ڴشС
#define Gui_PageCnt 8 //ҳ8ı
#define Use_Page0_As_RootPage 0   //


//

//&
//·[]ʾĻϵڵľꣻp()ʾҳpڵ꣬ҳp
//Կ,еĻͼҳp,pҳڵ꣬pp
//OLED12864Ͻ(0,0),½(128,64)

//op&font:
//opɫֵ0 1
//ַfont壬0:6*8С  1:8*16
//˵˻opfontĺ


typedef struct{  //ҳ һˢSimpleGuiĺݽṹ
    uint8_t PIdentify;   //Id 1ʼ0:Invalid
    int PStartx,PStarty,PSizex,PSizey;  //ҳxyʼλãĻϵľ꣩[x,y]ĬĻϽΪ[0,0],xңy£
    //uint8_t PDepth;//ֱӸҳȡֱӸҳ0
}Page;


//ʼģ
/*----------------------------Initialize------------------------------*/
#if (Use_Page0_As_RootPage==0) //ҪģҪʹ1ģʽˣڴ
void Gui_Init();//ʼGui
#else
void Gui_Init(Page *RootPage,int sizex,int sizey);//ʼGui
#endif
/*--------------------------------------------------------------------*/

//ڴģ
/*------------------------------Memory---------------------------------*/
uint8_t  Gui_GetPageId();//ΪҳId
uint8_t  Gui_FreePageId(uint8_t n);//ͷҳId
uint8_t  Gui_CreatePage(Page *p,int sizex,int sizey);//ҳ
uint8_t  Gui_FreePage(Page *p);//ͷҳ
uint16_t Gui_GetMemLeft();  //ȡʣڴ
/*--------------------------------------------------------------------*/



//ַģ
/*-------------------------------Text---------------------------------*/
void Gui_ShowChar(Page *p,int sx,int sy,uchar c,uchar op,uchar font) ;//ҳpϵp(sx,xy)λʾһַȡ磬Զȡ
//onelineָԶУضϵĵʾģʽ
//ûonelineָҳ߽ԶеĶģʽ
void Gui_ShowString(Page *p,int sx,int sy,uchar buffer[],uchar op,uchar font);
void Gui_ShowString_OneLine(Page *p,int sx,int sy,uchar buffer[],uchar op,uchar font);
void Gui_Printf(Page *p,int sx,int sy,uchar op,uchar font,const char *str,...);
void Gui_Printf_OneLine(Page *p,int sx,int sy,uchar op,uchar font,const char *str,...);
void Gui_ShowNum(Page *p,int sx,int sy,ulong num,uchar lenth,uchar mode,uchar op,uchar font);
void Gui_ShowNum_OneLine(Page *p,int sx,int sy,ulong num,uchar lenth,uchar mode,uchar op,uchar font);
/*--------------------------------------------------------------------*/



//ͼģ
/*------------------------------Graphic--------------------------------*/
void Gui_DrawPoint(Page *p,int x,int y,uchar op);//ҳpp(x,y)һɫopĵ(opȡ0/1)
uint8_t Gui_GetPoint(Page *p,int x,int y) ;//ȡҳpp(x,y)λõĵɫ(0/1)

void Gui_DrawLine(Page *p,int x_1,int y_1,int x_2,int y_2,uchar op) ;//ֱ߹p(x1,y1)p(x2,y2)

void Gui_DrawRectangleWired(Page *p,int sx,int sy,int sizex,int sizey,uint8_t op);//߿ Ͻp(sx,sy),sizexsizey
void Gui_DrawRectangleFilled(Page *p,int sx,int sy,int sizex,int sizey,uint8_t op);//ʵľ  Ͻp(sx,sy),sizexsizey

void Gui_DrawRectangleRound(Page *p,int sx,int sy,int sizex,int sizey,int r,uchar op);//ԲǾο   ԲǾӾοϽp(sx,sy),ֱ߲sizexֱ߲sizey,Բ뾶r

void Gui_DrawArc(Page *p,int ox,int oy,float theta1,float theta2,int r,uchar op);// p(ox,oy)ΪԲģrΪ뾶theta1תtheta2Ȼȣtheta2Ҫtheta1Ķ尴ոпαͨñ׼)
void Gui_DrawSec(Page *p,int ox,int oy,float theta1,float theta2,int r,uchar op);// p(ox,oy)ΪԲģ,rΪ뾶theta1תtheta2Ȼȣtheta2Ҫtheta1Ķ尴ոпαͨñ׼)

void Gui_DrawCircleWired(Page *p,int x,int y,int r,uchar op) ;//߿ԲԲp(x,y),뾶r
void Gui_DrawCircleFilled(Page *p,int x,int y,int r,uchar op) ;//ʵԲԲp(x,y),뾶r

void Gui_DrawTriangleWired(Page *p,int x_1,int y_1,int x_2,int y_2,int x_3,int y_3,uchar op);//p(x1,y1) p(x2,y2) p(x3,y3)㻭ο
void Gui_DrawTriangleFilled(Page *p,int x_1,int y_1,int x_2,int y_2,int x_3,int y_3,uchar op);//p(x1,y1) p(x2,y2) p(x3,y3)㻭ʵ
/*--------------------------------------------------------------------*/




//λͼģ
/*-------------------------------BMP----------------------------------*/
void Gui_DrawBmp(Page *p,int sx,int sy,int sizex,int sizey,uchar BMP[]) ;//λͼC51ʽԶȡ
void Gui_RotateBmp(Page *p,int ox,int oy,int sizex,int sizey,float theta,float alpha,uchar BMP[]);//תͼƬ.thetaǻȣalphaǱ,ܴ.ˢһӣ֮ǰһ
/*--------------------------------------------------------------------*/


//ģ
 /*---------------------------Control---------------------------------*/
void Gui_ClearBufferBit(Page *p,uchar op);//ҳ棬opָΪȫop=0,ȫop=1
void Gui_CopyPage(Page *From,Page *To,uint8_t op);//Fromҳ濽Toҳϣop=0: op=1: op=2: op=3:
void Gui_SetPosAbs(Page *p,int sx,int sy);//ҳϽǵľ[sx,sy]
void Gui_SetPosRel(Page *Ref,Page *p,int sx,int sy);//ҳRefRef(sx,sy)
void Gui_Flush(Page *px); //ҳ
/*--------------------------------------------------------------------*/



//ģ
/*---------------------------Interaction------------------------------*/
uint8_t Gui_TextBox(Page *p,int sx,int sy,uint8_t *Str,uchar op,uchar font);
//ģ
uint8_t Gui_MessageBox(Page *p,int sx,int sy,uint8_t *Title,uint8_t *Content,uint8_t Type);  //Ĭ
/*--------------------------------------------------------------------*/    
#endif
